//---------------------------------------------------------------------------
//  Mpcx.cpp
//  A "Graphics" unit's extention for PCX image format.
//  Copyright ( c ) 2000, 01 by Mental Studio - http://mentals.126.com
//  Author : Raptor - raptorz@163.com
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Mpcx.h"
#include "MpcxData.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

//  for MpcxData unit
extern "C" {

void * memalloc( int aSize )
{
	return ( void * )( new unsigned char [aSize] );
}

void memfree( void * aMem )
{
	delete aMem;
}

}

//---------------------------------------------------------------------------
//  TMPCXImage
//---------------------------------------------------------------------------
void __fastcall TMPCXImage::LoadFromStream( TStream * aStream )
{
	TMemoryStream * pPcx;
    TMemoryStream * pBmp;

    pPcx = dynamic_cast<TMemoryStream *>( aStream );
    if ( !pPcx )
    {
		pPcx = new TMemoryStream( );
        pPcx->CopyFrom( aStream, aStream->Size );
    }
    pBmp = new TMemoryStream( );
    try {
    	pBmp->Size = MPCX_Size( pPcx->Memory, pPcx->Size );
        if ( pBmp->Size > 0 )
        {
	        MPCX_Read( pPcx->Memory, pPcx->Size, pBmp->Memory );
            TBitmap::LoadFromStream( pBmp );
        }
    }
    __finally {
    	delete pBmp;
        if ( dynamic_cast<TMemoryStream *>( aStream ) != NULL )
        	delete pPcx;
    }
}

//---------------------------------------------------------------------------
void __fastcall TMPCXImage::SaveToStream( TStream * aStream )
{
	int n;
    TMemoryStream * pPcx;
    TMemoryStream * pBmp;

	pPcx = new TMemoryStream( );
    pBmp = new TMemoryStream( );
    try {
    	TBitmap::SaveToStream( pBmp );
        pPcx->Size = pBmp->Size + pBmp->Size / 2;
        n = MPCX_Write( pBmp->Memory, pBmp->Size, pPcx->Memory );
        if ( n > 0 )
        {
        	pPcx->Size = n;
	        aStream->CopyFrom( pPcx, n );
        }
    }
    __finally {
    	delete pBmp;
       	delete pPcx;
    }
}

//---------------------------------------------------------------------------
//initialization
//	TPicture.RegisterFileFormat( 'pcx', 'PCX Image Files', TMPCXImage );
//---------------------------------------------------------------------------
//finalization
//	TPicture.UnregisterGraphicClass( TMPCXImage );
//---------------------------------------------------------------------------

